;;;; uptime.scm - Display uptime. -*- scheme -*-
;;;; Copyright (C) 2003  Neal H. Walfield  <neal@cs.uml.edu>
;;;;
;;;; This file is part of Deride
;;;;
;;;; Deride is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2, or (at your option)
;;;; any later version.
;;;; 
;;;; Deride is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with the Deride; see the file COPYING.  If not, write to
;;;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-module (backend uptime))

(use-modules (comm hooks))
(use-modules (comm send))

(use-modules (conf deride))

(use-modules (utils utils))

(define start-time (current-time))

; (add-hook!
;  comm-received-forum-message-hook

(add-hook!
 comm-received-personal-message-hook
 (lambda (sender say msg)
   ;; Do not parse ourselves.
   (display msg)
   (if (string-ci=? msg "uptime")
       (send-to-user
	sender
	(let ((since (- (current-time) start-time)))
	  (cond
	   ((< since (* 15 60)) "I just got online a few minutes ago.")
	   ((< since (* 60 60))
	    (string-append "I have been on for "
			   (number->string (/ since 60))
			   " minutes."))
	   ((< since (* 2 24 60 60))
	    (string-append "I have been on for "
			   (number->string (/ since 60 60))
			   " hours."))
	   (else
	    (string-append "I have been online for "
			   (number->string (/ since 24 60 60))
			   " days."))))))))
					   

