;;;; send.scm - Implementations for the irc/send.scm interface. -*- scheme -*-
;;;; Copyright (C) 2002  Neal H. Walfield  <neal@cs.uml.edu>
;;;;
;;;; This file is part of Deride
;;;;
;;;; Deride is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2, or (at your option)
;;;; any later version.
;;;; 
;;;; Deride is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with the Deride; see the file COPYING.  If not, write to
;;;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-module (comm irc irc-send))

(use-modules (comm irc))
(use-modules (comm send))
(use-modules (comm hooks))
(use-modules (conf deride))

;; Implement send-to-forum.  See send.scm for more information.
(set! send-to-forum (lambda (forum message)
		      (irc-send (string-append
				 "PRIVMSG "
				 forum
				 " :"
				 message))
		      (run-hook comm-received-forum-message-hook
				deride-nick
				forum
				#f
				message)))

;; Implement send-to-forum.  See send.scm for more information.
(set! send-to-user (lambda (user message)
		     (irc-send (string-append
				"PRIVMSG "
				user
				" :"
				message))))
