;;;; send.scm - Interface for modules to "talk" to users -*- scheme -*-
;;;; Copyright (C) 2002  Neal H. Walfield  <neal@cs.uml.edu>
;;;;
;;;; This file is part of Deride
;;;;
;;;; Deride is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2, or (at your option)
;;;; any later version.
;;;; 
;;;; Deride is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with the Deride; see the file COPYING.  If not, write to
;;;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-module (comm send))

;; All of these variables must be set! by the communication back end.

;; To be defined to true if the communicaton backend supports the
;; ability to "say" things.  That is, if the equivalent of an irc
;; `/me' is supported.
(define-public send-can-say #f)

;; Send a message to a forum.  Must run the
;; comm-received-forum-message-hook hook.
(define-public send-to-forum (lambda (forum text) #f))

;; Say a message to a forum.  If the communication protocol does not
;; support this, it does not have to implement it.
(define-public say-to-forum (lambda (user text) #f))

;; Send a message to a particular user.
(define-public send-to-user (lambda (forum text) #f))

;; Say a message to a particular user.  If the communication protocol
;; does not support this, it does not have to implement it.
(define-public say-to-user (lambda (forum text) #f))
