#! /usr/bin/guile -s
!#

;;;; deride.scm - Main. -*- scheme -*-
;;;; Copyright (C) 2001  Neal H Walfield  <neal@cs.uml.edu>
;;;;
;;;; This file is part of Deride
;;;;
;;;; Deride is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2, or (at your option)
;;;; any later version.
;;;; 
;;;; Deride is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with the Deride; see the file COPYING.  If not, write to
;;;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(use-modules (comm irc))
(use-modules (conf deride))

(define (main)
  (letrec ((try-connect
	    (lambda (irc-servers)
	      (display irc-servers) (newline)
	      (client-display
	       (string-append "Connecting to "
			      (caar irc-servers) ":"
			      (number->string (cadar irc-servers))
			      "... "))
	      (or
	       (irc-connect (caar irc-servers) (cadar irc-servers))
	       (begin
		 (client-display "failed.\n")
		 (if (eq? (cddar irc-servers) '())
		     #f
		     (try-connect
		      (cons
		       (cons (caar irc-servers) (cddar irc-servers))
		       (cdr irc-servers)))))))))
    (let ((socket (try-connect irc-servers)))
      (if socket
	  (begin
	    (irc-send-login socket deride-nick deride-real-name)
	    (irc-send (string-append "JOIN " irc-channel))
	    (irc-loop socket)
	    
	    (client-display "Connection closed.\n"))
	  (begin
	    (client-display "Failed to connect; sleeping.\n")
	    (sleep 10)))))

  (main))

(main)